<html lang="en">
<head>
<title>eieio-persistent - Enhanced Implementation of Emacs Interpreted Objects</title>
<meta http-equiv="Content-Type" content="text/html">
<meta name="description" content="Enhanced Implementation of Emacs Interpreted Objects">
<meta name="generator" content="makeinfo 4.8">
<link title="Top" rel="start" href="index.html#Top">
<link rel="up" href="Base-Classes.html#Base-Classes" title="Base Classes">
<link rel="prev" href="eieio_002dsingleton.html#eieio_002dsingleton" title="eieio-singleton">
<link rel="next" href="eieio_002dnamed.html#eieio_002dnamed" title="eieio-named">
<link href="http://www.gnu.org/software/texinfo/" rel="generator-home" title="Texinfo Homepage">
<meta http-equiv="Content-Style-Type" content="text/css">
<style type="text/css"><!--
  pre.display { font-family:inherit }
  pre.format  { font-family:inherit }
  pre.smalldisplay { font-family:inherit; font-size:smaller }
  pre.smallformat  { font-family:inherit; font-size:smaller }
  pre.smallexample { font-size:smaller }
  pre.smalllisp    { font-size:smaller }
  span.sc    { font-variant:small-caps }
  span.roman { font-family:serif; font-weight:normal; } 
  span.sansserif { font-family:sans-serif; font-weight:normal; } 
--></style>
</head>
<body>
<div class="node">
<p>
<a name="eieio-persistent"></a>
<a name="eieio_002dpersistent"></a>
Next:&nbsp;<a rel="next" accesskey="n" href="eieio_002dnamed.html#eieio_002dnamed">eieio-named</a>,
Previous:&nbsp;<a rel="previous" accesskey="p" href="eieio_002dsingleton.html#eieio_002dsingleton">eieio-singleton</a>,
Up:&nbsp;<a rel="up" accesskey="u" href="Base-Classes.html#Base-Classes">Base Classes</a>
<hr>
</div>

<!-- node-name,  next,  previous,  up -->
<h3 class="section">12.3 <code>eieio-persistent</code></h3>

<p>This class is in package <samp><span class="file">eieio-base</span></samp>.

   <p>If you want an object, or set of objects to be persistent, meaning the
slot values are important to keep saved between sessions, then you will
want your top level object to inherit from <code>eieio-persistent</code>.

   <p>To make sure your persistent object can be moved, make sure all file
names stored to disk are made relative with
<code>eieio-persistent-path-relative</code>.

<div class="defun">
&mdash; Class: <b>eieio-persistent</b><var> file file-header-line<a name="index-eieio_002dpersistent-69"></a></var><br>
<blockquote><p>Enables persistence for instances of this class. 
Slot <var>file</var> with initarg <code>:file</code> is the file name in which this
object will be saved. 
Class allocated slot <var>file-header-line</var> is used with method
<code>object-write</code> as a header comment. 
</p></blockquote></div>

   <p>All objects can write themselves to a file, but persistent objects have
several additional methods that aid in maintaining them.

<div class="defun">
&mdash; Method on eieio-persistent: <b>eieio-persistent-save</b><var> obj &amp;optional file<a name="index-eieio_002dpersistent_002dsave-on-eieio_002dpersistent-70"></a></var><br>
<blockquote><p>Write the object <var>obj</var> to its file. 
If optional argument <var>file</var> is specified, use that file name
instead. 
</p></blockquote></div>

<div class="defun">
&mdash; Method on eieio-persistent: <b>eieio-persistent-path-relative</b><var> obj file<a name="index-eieio_002dpersistent_002dpath_002drelative-on-eieio_002dpersistent-71"></a></var><br>
<blockquote><p>Return a file name derived from <var>file</var> which is relative to the
stored location of <var>OBJ</var>.  This method should be used to convert
file names so that they are relative to the save file, making any system
of files movable from one location to another. 
</p></blockquote></div>

<div class="defun">
&mdash; Method on eieio-persistent: <b>object-write</b><var> obj &amp;optional comment<a name="index-object_002dwrite-on-eieio_002dpersistent-72"></a></var><br>
<blockquote><p>Like <code>object-write</code> for <code>standard-object</code>, but will derive
a header line comment from the class allocated slot if one is not
provided. 
</p></blockquote></div>

<div class="defun">
&mdash; Function: <b>eieio-persistent-read</b><var> filename<a name="index-eieio_002dpersistent_002dread-73"></a></var><br>
<blockquote><p>Read <var>filename</var> which contains an <code>eieio-persistent</code> object
previously written with <code>eieio-persistent-save</code>. 
</p></blockquote></div>

   </body></html>

